using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// The ChartControl sample form.
	/// </summary>
	public class FormMain : Form
	{
		private bool isDragging = false;
		private ChartRegion currentRegion = null;
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private System.Windows.Forms.PictureBox pictureBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(237)), ((System.Byte)(240)), ((System.Byte)(247)));
			this.chartControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.chartControl1.Legend});
			this.chartControl1.Depth = 50F;
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.chartControl1.Legend.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(237)), ((System.Byte)(240)), ((System.Byte)(247)));
			this.chartControl1.Legend.CustomItems = new Syncfusion.Windows.Forms.Chart.LegendItem[0];
			this.chartControl1.Legend.FloatingAutoSize = true;
			this.chartControl1.Legend.Location = new System.Drawing.Point(230, 49);
			this.chartControl1.Legend.RepresentationType = Syncfusion.Windows.Forms.Chart.ChartLegendRepresentationType.SeriesType;
			this.chartControl1.Legend.Size = new System.Drawing.Size(76, 28);
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Location = new System.Drawing.Point(8, 8);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Location = ((System.Drawing.PointF)(resources.GetObject("chartControl1.PrimaryXAxis.Location")));
			this.chartControl1.PrimaryXAxis.LocationType = Syncfusion.Windows.Forms.Chart.ChartAxisLocationType.Auto;
			this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.PrimaryXAxis.ZoomFactor = 1;
			this.chartControl1.PrimaryXAxis.ZoomPosition = 0;
			this.chartControl1.PrimaryYAxis.Location = ((System.Drawing.PointF)(resources.GetObject("chartControl1.PrimaryYAxis.Location")));
			this.chartControl1.PrimaryYAxis.LocationType = Syncfusion.Windows.Forms.Chart.ChartAxisLocationType.Auto;
			this.chartControl1.PrimaryYAxis.ZoomFactor = 1;
			this.chartControl1.PrimaryYAxis.ZoomPosition = 0;
			this.chartControl1.Rotation = 30F;
			this.chartControl1.Size = new System.Drawing.Size(536, 374);
			this.chartControl1.Spacing = 11F;
			this.chartControl1.TabIndex = 3;
			this.chartControl1.Text = "Essential Chart";
			this.chartControl1.Tilt = 30F;
			// 
			// chartControl1.ToolBar
			// 
			this.chartControl1.ToolBar.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(237)), ((System.Byte)(240)), ((System.Byte)(247)));
			this.chartControl1.ToolBar.ButtonBackColor = System.Drawing.SystemColors.ControlLight;
			this.chartControl1.ToolBar.ButtonFlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.chartControl1.ToolBar.ButtonForeColor = System.Drawing.SystemColors.ActiveBorder;
			this.chartControl1.ToolBar.ButtonSize = new System.Drawing.Size(32, 32);
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(26, 26);
			this.chartControl1.ToolBar.Size = new System.Drawing.Size(112, 50);
			this.chartControl1.ToolBar.Visible = false;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(8, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(374, 536);
			this.pictureBox1.TabIndex = 4;
			this.pictureBox1.TabStop = false;
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(416, 558);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chartControl1,
																		  this.pictureBox1});
			this.Name = "FormMain";
			this.Text = "Essential Chart -Spline Chart Orientation";
			this.Load += new System.EventHandler(this.FormMain_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		
		private void FormMain_Load(object sender, System.EventArgs e)
		{
			// Specify a ChartPalette
			this.chartControl1.Model.ColorModel.Palette = ChartColorPalette.Triad;

			InitializeChartData();
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			this.chartControl1.Indexed = false;
			
			ChartSeries series = this.chartControl1.Model.NewSeries("Series 1");
			series.Points.Add(0, 47);
			series.Points.Add(1, 57);
			series.Points.Add(2, 77);
			series.Points.Add(3, 87);
			series.Points.Add(4, 57);
								
			series.Type = ChartSeriesType.Spline;
			series.Text = series.Name;
			this.chartControl1.Series.Add(series);

			ExportToPictureBox(this.chartControl1);
		}

		private void ExportToPictureBox(ChartControl control)
		{
		
			try
			{
				// Export to a Image object
				Image img = new Bitmap(control.Width, control.Height);
				control.Draw(img);
				System.IO.Stream inMemStream = new System.IO.MemoryStream();//Create an in memory stream
				// Save to a in memory stream
				img.Save(inMemStream,ImageFormat.Bmp);

				// This part is only to show the saved image
				Bitmap wmfImage = new Bitmap(inMemStream);
				this.pictureBox1.Image = img;
				this.pictureBox1.Image.RotateFlip(RotateFlipType.Rotate270FlipNone);
				//this.pictureBox1.Size = new Size(control.Width ,control.Height);
				this.pictureBox1.Visible = true;
				this.chartControl1.Visible = false;
			}
			catch(Exception ex)
			{
				Console.WriteLine(ex.Message);
			}
			
		}
	}
}
